
dMatrix3 struct
	d1 real4 0.0
	d2 real4 0.0
	d3 real4 0.0
	d4 real4 0.0
	d5 real4 0.0
	d6 real4 0.0
	d7 real4 0.0
	d8 real4 0.0
	d9 real4 0.0
	d10 real4 0.0
	d11 real4 0.0
	d12 real4 0.0
	
dMatrix3 ends

dVector4 struct
	d1 real4 0.0
	d2 real4 0.0
	d3 real4 0.0
	d4 real4 0.0
dVector4 ends

dMass struct
	mass dword 0
	_c dVector4 <?>
	_i dMatrix3 <?>
dMass ends

object struct
	body dword 0
	mass dMass <?>
object ends

.data

DPElib dword 0
ODELib dword 0
world dword 0
obj object <?>

zt real4 -6.0
.code

InitDPE proc 
	
	invoke LoadLibrary,CADD("DevilPhysicEngine.dll")
	.if eax==0
		invoke MessageBox,0,CADD("Cannot load DPE."),0,0
		ret
	.endif
	mov DPElib,eax
	
	ret
InitDPE endp

InitODE proc
	
	invoke LoadLibrary,CADD("Ode.dll")
	.if eax==0
		invoke MessageBox,0,CADD("Cannot load ODE"),0,0
		ret
	.else
		mov ODELib,eax
		invoke GetProcAddress,ODELib,CADD("dWorldCreate")
		.if eax==0
			invoke PERR
		.endif
		call eax
		.if eax==0
			invoke PERR
		.else
			mov world,eax
			invoke GetProcAddress,ODELib,CADD("dWorldSetGravity")
			.if eax==0
				invoke PERR
			.endif
			
			push CFLT(0.0)
			push CFLT(-4.0)
			push CFLT(0.0)
			push world
			call eax
			add esp, 16
		.endif
		
	.endif
	
	ret
InitODE endp

TestODE proc uses esi edi
	LOCAL buff[256]:dword
	
	invoke GetProcAddress,ODELib,CADD("dBodyCreate")
	.if eax==0
		;invoke PERR
		ret
	.endif
	push world
	call eax
	add esp,4
	
	push eax
	pop obj.body
	
	invoke GetProcAddress,ODELib,CADD("dMassSetBox")
	.if eax==0
		;invoke PERR
		ret
	.endif
	
	push CFLT(1.0)
	push CFLT(1.0)
	push CFLT(1.0)
	push CFLT(100.0)
	push offset obj.mass
	call eax
	add esp,20
	
	invoke GetProcAddress,ODELib,CADD("dMassAdjust")
	.if eax==0
		;invoke PERR
		ret
	.endif
	
	push CFLT(0.05)
	push offset obj.mass
	call eax
	add esp,8
	; This function is error, I dont know what causing it, maybe miss definition the structure
	invoke GetProcAddress,ODELib,CADD("dBodySetMass")
	.if eax==0
		;invoke PERR
		ret
	.endif
	
	push offset obj.mass
	push obj.body
	call eax
	add esp,8
	; End of the error code
	
	invoke GetProcAddress,ODELib,CADD("dBodySetPosition")
	.if eax==0
		;invoke PERR
		ret
	.endif
	
	push CFLT(-6.0)
	push CFLT(2.0)
	push CFLT(-2.0)
	push obj.body
	call eax
	add esp, 16
	
	invoke GetProcAddress,ODELib,CADD("dBodySetLinearVel")
	.if eax==0
		;invoke PERR
		ret
	.endif
	
	push CFLT(0.0)
	push CFLT(0.0)
	push CFLT(-1.0)
	push obj.body
	call eax
	add esp,16
	
	
	ret
TestODE endp

BodyGetPosition proc
	
	invoke GetProcAddress,ODELib,CADD("dBodyGetPosition")
	.if eax==0
		invoke PERR
		xor eax,eax
		dec eax
		ret
	.endif
	
	push obj.body
	call eax
	add esp,4
	
	ret
BodyGetPosition endp

WorldQuickStep proc
	
	invoke GetProcAddress,ODELib,CADD("dWorldQuickStep")
	.if eax==0
		invoke PERR
		xor eax,eax
		dec eax
		ret
	.endif
	
	push CFLT(0.05)
	push world
	call eax
	add esp,8
	
	ret
WorldQuickStep endp

EndODE proc
	
	invoke GetProcAddress,ODELib,CADD("dWorldDestroy")
	.if eax!=0
		push world
		call eax
		add esp,4
	.else
		invoke PERR
	.endif
	
	invoke GetProcAddress,ODELib,CADD("dCloseODE")
	.if eax==0
		invoke PERR
	.else
		call eax
	.endif
	
	ret
EndODE endp